; Event Constants
#define REDRAW_EVENT 1
#define KEY_EVENT    2
#define BUTTON_EVENT 3

; Window Style Constants
#define WS_SKINNED_FIXED 0x4000000
#define WS_COORD_CLIENT  0x20000000
#define WS_CAPTION       0x10000000

; Caption Style Constant
#define CS_MOVABLE 0

; Event Mask Constants
#define EM_REDRAW 1
#define EM_KEY    2
#define EM_BUTTON 4

; Draw zero terminated string for DrawText
#define DT_ZSTRING 0x80000000

; Size multiplier for DrawText
#define DT_X2 0x1000000

#define WINDOW_BORDER_SIZE 5

; Button identifiesr
#define BUTTON_CLOSE 1

#define KEY_SCAN_ENTER 0x1C

#define TEXT_COLOR 0x551155
#define WINDOW_COLOR 0xCCDDEE

#define TEXT_X_MARGIN 45
#define TEXT_Y_MARGIN 25

#define CHAR_WIDTH 6
#define CHAR_HEIGHT 9

TButtonInput Struct
  MouseButton db ?
  ID          dw ?
  HiID        db ?
TButtonInput EndS

TKeyboardInput Struct
  Flag      db ?
  Code      db ?
  Union
    Scan    db ?
    Control dw ?
  EndS
TKeyboardInput EndS

TSize Struct
  Height dw ?
  Width  dw ?
TSize EndS

TRect Struct
  Left   dd ?
  Top    dd ?
  Right  dd ?
  Bottom dd ?
TRect EndS

CONST SECTION .rdata

szHello db "GoAsm with KolibriOS.lib",0
szPressEnter db "Press enter to quit app",0

DATA SECTION .data

Button TButtonInput <>
Key TKeyboardInput <>
Screen TSize <>
Window TRect <>

CODE SECTION .text

@Main:
        Invoke GetScreenSize
        mov    [Screen], eax
        Invoke GetSkinHeight
        add    eax, (CHAR_HEIGHT + TEXT_Y_MARGIN ) * 2 + WINDOW_BORDER_SIZE
        mov    [Window.Bottom], eax
        mov    D[Window.Right], (SizeOf szPressEnter * CHAR_WIDTH + WINDOW_BORDER_SIZE + TEXT_X_MARGIN) * 2
        movzx  eax, W[Screen.Width]
        movzx  ebx, W[Screen.Height]
        sub    eax, [Window.Right]
        sub    ebx, [Window.Bottom]
        shr    eax, 1
        shr    ebx, 1
        mov    [Window.Left], eax
        mov    [Window.Top], ebx
.loop:
        Invoke WaitEvent
        cmp    eax, REDRAW_EVENT
        jne    >
        Invoke BeginDraw
        Invoke DrawWindow, [Window.Left], [Window.Top], [Window.Right], [Window.Bottom], Offset szHello, WINDOW_COLOR, WS_SKINNED_FIXED | WS_COORD_CLIENT | WS_CAPTION, CS_MOVABLE
        Invoke DrawText, TEXT_X_MARGIN, TEXT_Y_MARGIN, Offset szPressEnter, TEXT_COLOR, 0, DT_ZSTRING | DT_X2, 0
        Invoke EndDraw
        jmp    .loop
:
        cmp    eax, KEY_EVENT
        jne    >
        Invoke GetKey
        mov    [Key], eax
        cmp    B[Key.Scan], KEY_SCAN_ENTER
        jne    .loop
        Invoke ThreadTerminate
:
        cmp    eax, BUTTON_EVENT
        jne    .loop
        Invoke GetButton
        mov    [Button], eax
        cmp    W[Button.ID], BUTTON_CLOSE
        jne    .loop
        Invoke ThreadTerminate